;/---------------------------\
;| Thorium Ressource Manager |
;|                           |
;| Example                   |
;|                           |
;| Version 0.01              |
;| Stand: 10.08.2008         |
;|                           |
;| PureBasic 4.20            |
;\---------------------------/

;Fr dieses Beispiel muss der test.trc Container in das Verzeichnis: C:\ResTest\
;Dorthin werden die Ressourcen auch entpackt zum test.

EnableExplicit

Import "ThoriumRessourceManager.lib"
  ResInitManager.l(RessourcePath.s,Language.l,CallbackAddr.l)
  ResLoad.l(ResName.s)
  ResChangeLang.l(Language.l)
  ResGetLastError.l()
EndImport

#ResError_NoAccessFile             = 1  ;kein Zugriff auf Datei
#ResError_WrongOrDmgArchiv         = 2  ;Archiv ist kein ThReCo oder beschdigt
#ResError_UnsupArchivFormat        = 3  ;nicht untersttztes Archivformat
#ResError_UnsupArchivFotmatVersion = 4  ;nicht untersttze Version des Archivformats
#ResError_UnsupCompInArchiv        = 5  ;nicht untersttzte Kompression wird im Archiv genutzt
#ResError_ArchivIsBig              = 6  ;Archiv ist grer als 2GB und dies wird nicht untersttzt
#ResError_ArchivIsHuge             = 7  ;Archiv ist grer als 4GB und dies wird nicht untersttzt
#ResError_UnsupDirComp             = 8  ;Directory des Archivs ist mit nicht untersttzter Kompression komprimiert
#ResError_AllocMem                 = 9  ;Speicher konnte nicht alloziert werden
#ResError_ReadFile                 = 10 ;konnte Datei nicht auslesen
#ResError_Decomp                   = 11 ;konnte nicht dekomprimieren
#ResError_NoAccessDir              = 12 ;kein Zugriff auf Verzeichnis
#ResError_OutOfIndex               = 13 ;ausserhalb des gltigen Bereichs
#ResError_ResNotFound              = 14 ;Ressource konnte nicht gefunden werden

#ResLang_German  = 1
#ResLang_English = 2

Global ImageRes.l,TextRes.l
Global ImageResAddr.l,TextResAddr.l
Global ImageResSize.l,TextResSize.l
Global ImageResLoaded.l,TextResLoaded.l
Global Exit.l

Procedure Callback(ResIndex.l,Addr.l,Size.l,Error.l)

  Select ResIndex
  
    Case ImageRes
      If Error = 0
        ImageResAddr = Addr
        ImageResSize = Size
        ImageResLoaded = 1
      Else
        ImageResLoaded = 3
      EndIf
    
    Case TextRes
      If Error = 0
        TextResAddr = Addr
        TextResSize = Size
        TextResLoaded = 1
      Else
        TextResLoaded = 3
      EndIf
  
  EndSelect

EndProcedure

;Um den Multilanguage Support zu testen hier einfach #ResLang_German durch #ResLang_English ersetzen.
If ResInitManager("C:\ResTest\",#ResLang_German,@Callback()) = 0
  MessageRequester("Example","Init failed!",16)
  End
EndIf

ImageRes = ResLoad("bild.bmp")
TextRes = ResLoad("text.txt")

Repeat

  Delay(50)

  If ImageResLoaded = 1
  
    Debug "bild.bmp wurde geladen"
    CatchImage(0,ImageResAddr)
    SaveImage(0,"C:\ResTest\bild.bmp")
    ImageResLoaded = 2
  
  ElseIf ImageResLoaded = 3
  
    Debug "bild.bmp konnte nicht geladen werden!"
    ImageResLoaded = 2
  
  EndIf
  
  If TextResLoaded = 1
  
    Debug "text.txt wurde geladen"
    CreateFile(0,"C:\ResTest\bild.txt")
    WriteData(0,TextResAddr,TextResSize)
    CloseFile(0)
    TextResLoaded = 2
  
  ElseIf TextResLoaded = 3
  
    Debug "text.txt konnte nicht geladen werden!"
    TextResLoaded = 2  
  
  EndIf
  
  If ImageResLoaded = 2 And TextResLoaded = 2
    Exit = 1
  EndIf
  
Until Exit = 1

End

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 76
; FirstLine = 54
; Folding = -
; EnableXP